# NoxOS

NoxOS is a small x86 operating system (currently just a kernel).
The kernel is booted using the limine boot protocol and is fully documented.

# Roadmap

- [x] Bootable system
- [x] Logger
- [x] Page frame manager
- [x] Interrupts
- [x] Page maps
- [x] Heap
- [x] Format strings
- [x] Graphics Renderer
  - [x] Text
  - [x] Double buffering
  - [x] Buffer requests
- [x] Panic Screen
  - [x] Register dump
  - [x] Stack tracing
- [x] Scheduler
  - [x] Threads
  - [x] Processes
- [x] Ramdisk
  - [x] USTAR
  - [x] RAMFS
  - [x] VFS
- [x] ELF loading
- [x] Keyboard input (ps/2 int)
- [x] JSON parser for system config
- [ ] Drivers
  - [X] Loading / Linking into kernel
  - [X] Driver Device assignment (PCI / USB / FS)
  - [ ] API
- [ ] Syscalls
  - [x] Filesystem
  - [x] Memory
  - [ ] Processing
  - [x] Drivers
  - [X] Kernel
- [ ] FAT32 (driver)
- [ ] TUI framework
- [ ] Shell
- [ ] Text Editor
- [ ] TCC
- [ ] Tetris
- [ ] Init System

## Contribution Welcome :D

Install instructions, Code Documentation and a Contribution guide can be found [here](https://git.nerdcult.net/noxos/documentation).

## Copyright / License (MIT)
Copyright 2023 Antifallobst <antifallobst@systemausfall.org>

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the “Software”), to deal in
the Software without restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
Software, and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
