// This file is part of noxos and licensed under the MIT open source license

#ifndef NOX_RSDP_H
#define NOX_RSDP_H

#include "utils/stdtypes.h"

typedef struct {
    char                    signature           [8];
    uint8_t                 checksum;
    char                    oem_id              [6];
    uint8_t                 revision;
    uint32_t                rsdt_address;
} __attribute__((packed)) rsdp_descriptor_v1_T;

typedef struct {
    rsdp_descriptor_v1_T    descriptor_v1;
    uint32_t                length;
    uint64_t                xsdt_address;
    uint8_t                 checksum_extended;
    uint8_t                 reserved            [3];
} __attribute__((packed)) rsdp_descriptor_v2_T;

bool    rsdp_descriptor_v1_verify(rsdp_descriptor_v1_T* descriptor);
bool    rsdp_descriptor_v2_verify(rsdp_descriptor_v2_T* descriptor);

#endif //NOX_RSDP_H
