// This file is part of noxos and licensed under the MIT open source license

#ifndef NOX_COLOR_H
#define NOX_COLOR_H

#include "utils/stdtypes.h"

// Colors from https://gogh-co.github.io/Gogh/
typedef enum {
    COLOR_PAL_GREY_DARK,
    COLOR_PAL_PINK,
    COLOR_PAL_GREEN_SIGNAL,
    COLOR_PAL_ORANGE,
    COLOR_PAL_BLUE,
    COLOR_PAL_PURPLE,
    COLOR_PAL_GREEN,
    COLOR_PAL_GREY_LIGHT,
    COLOR_PAL_RED,

    COLOR_PAL_ENUM_END
} color_palette_E;

typedef struct {
    uint8_t alpha;
    uint8_t red;
    uint8_t green;
    uint8_t blue;
} color_argb_T;

extern color_argb_T g_color_palette[COLOR_PAL_ENUM_END];

color_argb_T color_argb_blend_alpha(color_argb_T background, color_argb_T foreground);

#endif //NOX_COLOR_H
