// This file is part of noxos and licensed under the MIT open source license

#ifndef NOXOS_TTY_H
#define NOXOS_TTY_H

#include "drivers/builtin/graphics/renderer.h"
#include "utils/stream.h"
#include "proc/pipe.h"

typedef struct {
    graphics_buffer_T*  graphics_buffer;
    pipe_T*             output;
    pipe_T              input;
    graphics_buffer_T*  cursor_overlay;
    position_T          cursor;
    color_argb_T        color;
} tty_T;

void        tty_init        ();
void        tty_update      ();
uint32_t    tty_write       (string_t string);

extern tty_T* g_tty;

#endif //NOXOS_TTY_H
