// This file is part of noxos and licensed under the MIT open source license

#include <drivers/driver.h>
#include <utils/logger.h>
#include <mm/stack.h>

void nx_drv_pci_config(driver_config_pci_T* config) {
    driver_T* driver = driver_lookup_by_address((void*)stack_get_caller());
    if (driver == NULL) return;

    driver_init(driver, DRIVER_TRANSPORT_PCI, (conf_U)config);
}

void nx_drv_usb_config(driver_config_usb_T* config) {
    driver_T* driver = driver_lookup_by_address((void*)stack_get_caller());
    if (driver == NULL) return;

    driver_init(driver, DRIVER_TRANSPORT_USB, (conf_U)config);
}

void nx_drv_fs_config(driver_config_fs_T* config) {
    driver_T* driver = driver_lookup_by_address((void*)stack_get_caller());
    if (driver == NULL) return;

    driver_init(driver, DRIVER_TRANSPORT_FS, (conf_U)config);
}

void nx_drv_log(string_t string) {
    log(LOG_INFO, "DRIVER -> %s", string);
}