// This file is part of noxos and licensed under the MIT open source license

#include "drivers/builtin/acpi/rsdp.h"

bool rsdp_descriptor_v1_verify(rsdp_descriptor_v1_T* descriptor) {
    uint8_t* data = (uint8_t*)descriptor;
    uint32_t num  = 0;

    for (uint8_t i = 0; i < sizeof(rsdp_descriptor_v1_T); i++) {
        num += data[i];
    }

    return ((num & 0xFF) == 0);
}

bool rsdp_descriptor_v2_verify(rsdp_descriptor_v2_T* descriptor) {
    if (!rsdp_descriptor_v1_verify(&descriptor->descriptor_v1)) {
        return false;
    }

    uint8_t* data = (uint8_t*)descriptor + sizeof(rsdp_descriptor_v1_T);
    uint32_t num  = 0;

    for (uint8_t i = 0; i < sizeof(rsdp_descriptor_v2_T) - sizeof(rsdp_descriptor_v1_T); i++) {
        num += data[i];
    }

    return ((num & 0xFF) == 0);
}
