// This file is part of noxos and licensed under the MIT open source license

#include "drivers/builtin/fs/gpt.h"
#include "utils/memory.h"

uint8_t g_gpt_partition_type_guides[GPT_PARTITION_GUID_ENUM_END][16] = {
        { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
        { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
        { 0xA2, 0xA0, 0xD0, 0xEB, 0xE5, 0xB9, 0x33, 0x44, 0x87, 0xC0, 0x68, 0xB6, 0xB7, 0x26, 0x99, 0xC7 },
        { 0x28, 0x73, 0x2A, 0xC1, 0x1F, 0xF8, 0xD2, 0x11, 0xBA, 0x4B, 0x00, 0xA0, 0xC9, 0x3E, 0xC9, 0x3B }
};

gpt_partition_type_guids_E gpt_get_partition_type(uint8_t guid[16]) {
    for (int i = 0; i < GPT_PARTITION_GUID_ENUM_END; i++) {
        if (memory_compare(guid, g_gpt_partition_type_guides[i], 16)) {
            return (gpt_partition_type_guids_E) i;
        }
    }
    return GPT_PARTITION_GUID_UNKNOWN;
}

string_t gpt_partition_type_to_string(gpt_partition_type_guids_E type) {
    switch (type) {
        case GPT_PARTITION_GUID_UNUSED:     return "Unused";
        case GPT_PARTITION_GUID_PRIMARY:    return "Primary";
        case GPT_PARTITION_GUID_EFI_SYSTEM: return "EFI System";

        case GPT_PARTITION_GUID_UNKNOWN:
        default:                            return "Unknown";
    }
}