// This file is part of noxos and licensed under the MIT open source license

#include "drivers/builtin/fs/mbr.h"

string_t mbr_partition_type_to_string(mbr_partition_types_E type) {
    switch (type) {
        case MBR_PARTITION_TYPE_UNUSED:     return "Unused";
        case MBR_PARTITION_TYPE_GPT:        return "GUID Partition Table";
        case MBR_PARTITION_TYPE_EXT2:       return "EXT2";
        case MBR_PARTITION_TYPE_FAT12:      return "FAT12";
        case MBR_PARTITION_TYPE_FAT16:      return "FAT16";
        case MBR_PARTITION_TYPE_FAT32_CHS:  return "FAT32 (CHS)";
        case MBR_PARTITION_TYPE_FAT32_LBA:  return "FAT32 (LBA)";
        default:                            return "Unknown";
    }
}