// This file is part of noxos and licensed under the MIT open source license

#include "drivers/builtin/graphics/color.h"

color_argb_T g_color_palette[COLOR_PAL_ENUM_END] = {
        {0xFF, 0x36, 0x36, 0x36},   // GREY_DARK
        {0xFF, 0xFF, 0x08, 0x83},   // PINK
        {0xFF, 0x83, 0xff, 0x08},   // GREEN_SIGNAL
        {0xFF, 0xFF, 0x83, 0x08},   // ORANGE
        {0xFF, 0x08, 0x83, 0xFF},   // BLUE
        {0xFF, 0x83, 0x08, 0xFF},   // PURPLE
        {0xFF, 0x08, 0xFF, 0x83},   // GREEN
        {0xFF, 0xB6, 0xB6, 0xB6},   // GREY_LIGHT
        {0xFF, 0xFF, 0x00, 0x00},   // RED
};

color_argb_T color_argb_blend_alpha(color_argb_T background, color_argb_T foreground) {
    color_argb_T color;
    color.red   = ((foreground.red   * foreground.alpha) + (background.red   * (0xFF - foreground.alpha))) / 0xFF;
    color.green = ((foreground.green * foreground.alpha) + (background.green * (0xFF - foreground.alpha))) / 0xFF;
    color.blue  = ((foreground.blue  * foreground.alpha) + (background.blue  * (0xFF - foreground.alpha))) / 0xFF;

    return color;
}
