// This file is part of noxos and licensed under the MIT open source license

#include "drivers/builtin/time/pit.h"
#include "utils/io.h"
#include "utils/logger.h"

uint16_t g_divisor;

void pit_set_divisor(uint16_t divisor) {
    if (divisor < 100) { divisor = 100; }

    g_divisor = divisor;

    io_out_byte(PIT_CHANNEL_0_PORT, divisor & 0x00FF); io_wait();
    io_out_byte(PIT_CHANNEL_0_PORT, (divisor & 0xFF00) >> 8);

    log(LOG_INFO, "pit -> divisor set to %d", divisor);
}