// This file is part of noxos and licensed under the MIT open source license

#include "mm/memory_map.h"
#include "utils/logger.h"

uint64_t memory_map_get_total_memory_size(boot_info_T* boot_info) {
    static uint64_t size = 0;
    if (size > 0) {
        log(LOG_INFO, "Memory size is already calculated: %d", size);
        return size;
    };

    for (int i = 0; i < boot_info->memory_map->entry_count; i++) {
        struct limine_memmap_entry* entry = boot_info->memory_map->entries[i];
        size += entry->length;
    }

    return size;
}