// This file is part of noxos and licensed under the MIT open source license

#include "platform/exceptions.h"
#include "utils/panic.h"

string_t g_exception_type_strings[EXCEPTIONS_ENUM_END] = {
        "Division Error",
        "Debug Exception",
        "Non Maskable Interrupt",
        "Breakpoint Exception",
        "Overflow Exception",
        "Bound Range Exceeded Exception",
        "Invalid Opcode",
        "Device Not Available",
        "Double Fault",
        "[ DEPRECATED ] Coprocessor Segment Overrun",
        "Invalid TSS",
        "Segment Not Present",
        "Stack Segment Fault",
        "General Protection Fault",
        "Page Fault",
        "RESERVED EXCEPTION",
        "x87 Floating Point Exception",
        "Alignment Check",
        "Machine Check",
        "SIMD Floating Point Exception",
        "Virtualization Exception",
        "Control Protection Exception",
        "RESERVED EXCEPTION",
        "RESERVED EXCEPTION",
        "RESERVED EXCEPTION",
        "RESERVED EXCEPTION",
        "RESERVED EXCEPTION",
        "RESERVED EXCEPTION",
        "Hypervisor Injection Exception",
        "VMM Communication Exception",
        "Security Exception"
};

cpu_state_T* exception_handle(cpu_state_T* state) {
    panic(state, g_exception_type_strings[state->interrupt_id]);
}