// This file is part of noxos and licensed under the MIT open source license

#include "platform/gdt.h"
#include "utils/logger.h"

extern void gdt_load(gdt_descriptor_T* gdt_descriptor);

__attribute__((aligned(0x1000)))
gdt_T g_default_gdt = {
        {0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
        {0x00, 0x00, 0x00, 0x9A, 0xA0, 0x00},
        {0x00, 0x00, 0x00, 0x92, 0xA0, 0x00},
        {0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
        {0x00, 0x00, 0x00, 0x9A, 0xA0, 0x00},
        {0x00, 0x00, 0x00, 0x92, 0xA0, 0x00}
};

void gdt_init() {
    gdt_descriptor_T  descriptor;

    descriptor.size   = sizeof(gdt_T) - 1;
    descriptor.offset = (uint64_t)&g_default_gdt;

    gdt_load(&descriptor);
    log(LOG_INFO, "GDT loaded");
}