// This file is part of noxos and licensed under the MIT open source license

#include "utils/io.h"

void io_out_byte(uint16_t port, uint8_t data) {
    asm volatile ("outb %0, %1" :  : "a"(data), "Nd"(port));
}

uint8_t io_in_byte(uint16_t port) {
    uint8_t data;
    asm volatile ("inb %1, %0" : "=a"(data) : "Nd"(port));
    return data;
}

void io_out_word(uint16_t port, uint32_t data) {
    asm volatile ("outl %0, %1" :  : "a"(data), "Nd"(port));
}

uint32_t io_in_word(uint16_t port) {
    uint32_t data;
    asm volatile ("inl %1, %0" : "=a"(data) : "Nd"(port));
    return data;
}

void io_wait() {
    io_out_byte(0x80, 0);
}
